summaryrefslogtreecommitdiff
path: root/plugins/ssh-agent
diff options
context:
space:
mode:
authorMarc Cornellà <hello@mcornella.com>2021-11-17 09:55:39 +0100
committerMarc Cornellà <hello@mcornella.com>2021-11-17 09:55:39 +0100
commit60b89cd264a5d889573704f5116cefc8e690062c (patch)
tree112563401f04e476047aae12c4aae511365669d0 /plugins/ssh-agent
parentfb12e4135311b9c4189a7e4556be619922052f6b (diff)
downloadzsh-60b89cd264a5d889573704f5116cefc8e690062c.tar.gz
zsh-60b89cd264a5d889573704f5116cefc8e690062c.tar.bz2
zsh-60b89cd264a5d889573704f5116cefc8e690062c.zip
feat(ssh-agent): add `quiet` option to silence plugin (#9659)
Closes #9659 Co-authored-by: Jeff Warner <jeff@develops.software>
Diffstat (limited to 'plugins/ssh-agent')
-rw-r--r--plugins/ssh-agent/README.md56
-rw-r--r--plugins/ssh-agent/ssh-agent.plugin.zsh12
2 files changed, 38 insertions, 30 deletions
diff --git a/plugins/ssh-agent/README.md b/plugins/ssh-agent/README.md
index 1d6914ec6..fa6a996d4 100644
--- a/plugins/ssh-agent/README.md
+++ b/plugins/ssh-agent/README.md
@@ -13,28 +13,24 @@ plugins=(... ssh-agent)
**IMPORTANT: put these settings _before_ the line that sources oh-my-zsh**
+### `agent-forwarding`
+
To enable **agent forwarding support** add the following to your zshrc file:
```zsh
-zstyle :omz:plugins:ssh-agent agent-forwarding on
+zstyle :omz:plugins:ssh-agent agent-forwarding yes
```
-----
+### `helper`
-To **NOT load any identities on start** use the `lazy` setting. This is particularly
-useful when combined with the `AddKeysToAgent` setting (available since OpenSSH 7.2),
-since it allows to enter the password only on first use. _NOTE: you can know your
-OpenSSH version with `ssh -V`._
+To set an **external helper** to ask for the passwords and possibly store
+them in the system keychain use the `helper` style. For example:
```zsh
-zstyle :omz:plugins:ssh-agent lazy yes
+zstyle :omz:plugins:ssh-agent helper ksshaskpass
```
-You can enable `AddKeysToAgent` by passing `-o AddKeysToAgent=yes` to the `ssh` command,
-or by adding `AddKeysToAgent yes` to your `~/.ssh/config` file [1].
-See the [OpenSSH 7.2 Release Notes](http://www.openssh.com/txt/release-7.2).
-
-----
+### `identities`
To **load multiple identities** use the `identities` style (**this has no effect
if the `lazy` setting is enabled**). For example:
@@ -52,7 +48,22 @@ zstyle :omz:plugins:ssh-agent identities ~/.config/ssh/id_rsa ~/.config/ssh/id_r
zstyle :omz:plugins:ssh-agent identities ~/.config/ssh/{id_rsa,id_rsa2,id_github}
```
-----
+### `lazy`
+
+To **NOT load any identities on start** use the `lazy` setting. This is particularly
+useful when combined with the `AddKeysToAgent` setting (available since OpenSSH 7.2),
+since it allows to enter the password only on first use. _NOTE: you can know your
+OpenSSH version with `ssh -V`._
+
+```zsh
+zstyle :omz:plugins:ssh-agent lazy yes
+```
+
+You can enable `AddKeysToAgent` by passing `-o AddKeysToAgent=yes` to the `ssh` command,
+or by adding `AddKeysToAgent yes` to your `~/.ssh/config` file [1].
+See the [OpenSSH 7.2 Release Notes](http://www.openssh.com/txt/release-7.2).
+
+### `lifetime`
To **set the maximum lifetime of the identities**, use the `lifetime` style.
The lifetime may be specified in seconds or as described in sshd_config(5)
@@ -62,7 +73,15 @@ The lifetime may be specified in seconds or as described in sshd_config(5)
zstyle :omz:plugins:ssh-agent lifetime 4h
```
-----
+### `quiet`
+
+To silence the plugin, use the following setting:
+
+```zsh
+zstyle :omz:plugins:ssh-agent quiet yes
+```
+
+### `ssh-add-args`
To **pass arguments to the `ssh-add` command** that adds the identities on startup,
use the `ssh-add-args` setting. You can pass multiple arguments separated by spaces:
@@ -80,15 +99,6 @@ ssh-add -K -c -a /run/user/1000/ssh-auth <identities>
For valid `ssh-add` arguments run `ssh-add --help` or `man ssh-add`.
-----
-
-To set an **external helper** to ask for the passwords and possibly store
-them in the system keychain use the `helper` style. For example:
-
-```zsh
-zstyle :omz:plugins:ssh-agent helper ksshaskpass
-```
-
## Credits
Based on code from Joseph M. Reagle: https://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
diff --git a/plugins/ssh-agent/ssh-agent.plugin.zsh b/plugins/ssh-agent/ssh-agent.plugin.zsh
index 47dfef5b0..0d6a35b35 100644
--- a/plugins/ssh-agent/ssh-agent.plugin.zsh
+++ b/plugins/ssh-agent/ssh-agent.plugin.zsh
@@ -18,7 +18,7 @@ function _start_agent() {
zstyle -s :omz:plugins:ssh-agent lifetime lifetime
# start ssh-agent and setup environment
- echo Starting ssh-agent...
+ zstyle -t :omz:plugins:ssh-agent quiet || echo >&2 "Starting ssh-agent ..."
ssh-agent -s ${lifetime:+-t} ${lifetime} | sed '/^echo/d' >! "$ssh_env_cache"
chmod 600 "$ssh_env_cache"
. "$ssh_env_cache" > /dev/null
@@ -78,7 +78,7 @@ function _add_identities() {
if [[ -n "$helper" ]]; then
if [[ -z "${commands[$helper]}" ]]; then
- echo "ssh-agent: the helper '$helper' has not been found."
+ echo >&2 "ssh-agent: the helper '$helper' has not been found."
else
SSH_ASKPASS="$helper" ssh-add "${args[@]}" ${^not_loaded} < /dev/null
return $?
@@ -88,11 +88,9 @@ function _add_identities() {
ssh-add "${args[@]}" ${^not_loaded}
}
-# test if agent-forwarding is enabled
-zstyle -b :omz:plugins:ssh-agent agent-forwarding agent_forwarding
-
-# Add a nifty symlink for screen/tmux if agent forwarding
-if [[ $agent_forwarding = "yes" && -n "$SSH_AUTH_SOCK" && ! -L "$SSH_AUTH_SOCK" ]]; then
+# Add a nifty symlink for screen/tmux if agent forwarding is enabled
+if zstyle -t :omz:plugins:ssh-agent agent-forwarding \
+ && [[ -n "$SSH_AUTH_SOCK" && ! -L "$SSH_AUTH_SOCK" ]]; then
ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USERNAME-screen
else
_start_agent